//幻灯片
function mobile_scroll(obj){
	obj=$.extend({pic:".pic",num:".num",leftbtn:".leftbtn",rightbtn:".rightbtn","scale":960/330,speed:200,t:5000,e:"click"},obj);
	var box = $(obj.box);
	var pic = $(obj.pic);
	var picli = pic.children();
	var num = $(obj.num);
	var numli = num.children();
	var leftbtn = $(obj.leftbtn);
	var rightbtn = $(obj.rightbtn);
	var len = picli.length;
	if(len==0)return;
	var wid = box.width();
	var cur = 0;
	var speed = obj.speed;
	var isdone = true;
	var ti = null;
	clearInterval(ti);
	var posfun = function(i){
		if(len==1)return;
		pic.find(".clone").remove();
		if(i<0)i=len-1;
		if(i>len-1)i=0;
		var prev = i-1;
		if(i<=0)prev = len-1;
		var next = i+1;
		if(i>=len-1)next = 0;
		var clone = picli.eq(prev).clone().addClass("clone");
		pic.append(clone);
		clone.css({left:0});
		picli.eq(i).css({left:wid});
		picli.eq(next).css({left:2*wid});
		if(len>2)picli.eq(prev).css({left:3*wid});
		pic.css({left:-wid});
		cur = i;
		picli.removeClass("on").eq(i).addClass("on");
		numli.removeClass("on").eq(i).addClass("on");
		cur=i;
		isdone = true;
	}
	//posfun(0);
	$(window).resize(function () {
		wid = box.width();
		box.height(wid / obj.scale);
		pic.height(wid / obj.scale);
		picli.width(wid);
		pic.width((len+1)*wid);
		posfun(0);
	}).trigger("resize");
	
	if(len==1){
		num.remove();
		picli.css("position","relative");
		return;
	}
	
	var moving = function(i){
		if(!isdone)return;
		isdone = false;
		if(i==cur)pic.stop().animate({left:-wid},speed,function(){posfun(i);});
		else if(i<cur)pic.stop().animate({left:0},speed,function(){posfun(i);});
		else pic.stop().animate({left:-2*wid},speed,function(){posfun(i);});
	}
	numli.click(function(){
		var i = $(this).index();
		if(i==cur)return false;
		moving(i);
	})
	leftbtn.click(function(){moving(cur-1)});
	rightbtn.click(function(){moving(cur+1)});
	
	var startx,endx,startl,tempx;
	pic.on({
		touchstart:function (e) {
			var touch = e.originalEvent.targetTouches[0];
			startl = pic.position().left;
			startx = parseInt(touch.pageX);
		},
		touchmove:function (e) {
			e.preventDefault();//重要,不写就touchend失灵
			var touch = e.originalEvent.targetTouches[0];
			var sleft = pic.position().left;
			endx = parseInt(touch.pageX);
			var ww=endx-startx+startl;
			if(ww>=0||ww<=-2*wid)return false;
			pic.css({left:ww});
		},
		touchend:function (e) {
			if(endx==tempx)return;
			var n = cur;
			if(endx<startx-50)n++;
			if(endx>startx+50)n--;
			moving(n);
			tempx = endx;
			}
	});
	
	/*自动播放*/	
	box.on("touchstart",function(){
		clearInterval(ti);
		/*
		if(typeof(api)!="undefined")
		api.setFrameAttr({
			bounces: false
		});
		*/
	});
	box.on("touchend",function(){
		/*
		if(typeof(api)!="undefined"&&isdownfresh)
		api.setFrameAttr({
			bounces: true
		});
		*/
		clearInterval(ti);
		ti = setInterval(function () {
			moving(cur+1);
		}, obj.t);
	}).trigger("touchend");
};
//mobile_scroll({box:"#banner",pic:"#banner .pic",num:"#banner .num","scale":720/310,speed:200,t:5000});