//Config
(function ($) {
    var APP_DOMAIN="http://192.168.1.181/";
    var extend={
        C:{
            APP_DOMAIN: "http://192.168.1.181/",
            APP_ROOT:APP_DOMAIN + "mob.php",
            APP_URL:APP_DOMAIN + "mob.php",
            AJAXOUT:1E4,
            OPENSPEED:200,
            WANMEL:"pop-in"
        },
        Main:null,
        info:null,
        pagename:null,
        p:function(arg) {
            var msg=window.pagename+">>";
            msg+=p.caller&&p.caller.name?(p.caller.name+'>>'):'';
            msg+=JSON.stringify(arg);
            console.log(msg);
        },
        store:{
            set: function(key, val) {
                window.localStorage.setItem(key, val);
            },
            get: function(key) {
                return window.localStorage.getItem(key)
            },
            oset: function(key, val) {
                window.localStorage.setItem(key, JSON.stringify(val));
            },
            oget: function(key) {
                return JSON.parse(window.localStorage.getItem(key))
            },
            remove: function(key) {
                window.localStorage.removeItem(key)
            },
            clear: function() {
                window.localStorage.clear()
            }
        },
        checkLogin:function(){
            return !!store.get("token");
        },
        alltouch:function (obj) {
            p('传递全局touch');
            var wvs = plus.webview.all(),
                cwv=plus.webview.currentWebview();
            $.each(ws, function(i,wv) {
                if (wv!=cwv) {
                    p('fire--' + wv.id);
                    mui.fire(wv,  "rootTouch", obj);
                };
            });
        }
    };
    //暴露属性
    $.extend(window,extend);
})(window.$||window.mui);
//Ajax
(function ($) {
    var Task=function(name,runner){
        this.name=name;
        this.status=0;
        this.count=0;
        this.run=function(){
            runner(name);
        };
    };
    /**
     *
     * @constructor
     */
    var TaskCenter=function () {
        var self=this,
            tasks=null;
        this.getTask=function (name) {
            if(tasks)
                for(var i in tasks){
                    if(tasks[i].name==name)
                        return tasks[i];
                }
            return null;
        };
        this.runFaild=function(){
            switch(this.status()){
                case 1:
                	this.reset();
                    info.ajaxloaded++;
                    break;
                case 3:
                    runajax();
                    break;
            }
        };
        this.status=function () {
            var status=0;
            if(tasks){
                status=1;
                for(var i in tasks){
                    if(tasks[i].status==0){
                        status=2;
                        return status;
                    }else if(tasks[i].status==2){
                        status=3
                    }
                }
                return status;
            }else{
                return status;
            }
        };
        this.reset=function () {
            tasks=null;
            ajaxobjrun={};
        }
        this.getTasks=function(){
            if(tasks){
                return tasks;
            }
            tasks=[];
            var names=Object.keys(ajaxobjrun);
            for(var i=0;i<names.length;i++){
                tasks.push(new Task(names[i],ajaxobjrun[names[i]]));
            }
            return tasks;
        };
    }
    var taskCenter=new TaskCenter();
    var extend={
        ajaxobj:{},
        ajaxobjrun:{},
        online:true,
        ga:function(args) {        	
        	var arr=(typeof arr=="string")?arguments:args;
			ajaxobjrun = {};
			$(arr).each(function() {
				ajaxobjrun[this] = ajaxobj[this];
			});
			runajax();
		},
        ajax_s:function (name, url, params, callback) {
            var task=taskCenter.getTask(name);
                 args=arguments;
            task.count++;
            $.ajax({
                url:C.APP_ROOT+url,
                data:params,
                timeout:10000,
                dataType: 'json', //服务器返回json格式数据
                type: 'post', //HTTP请求类型
                timeout: 10000, //超时时间设置为10秒；
                beforeSend: function () {
                    if(!online){
                        task.status=2;
                        task.msg="网络异常";
                        return;
                    }
                    online=(plus.networkinfo.getCurrentType() != plus.networkinfo.CONNECTION_NONE);
                    if(online)return true;
                    mui.confirm("当前网络不给力，请连接网络后重试!", "网络连接故障", function(e) {
                        plus.nativeUI.closeWaiting();
                        task.status=2;
                        if (e.index) {
                            runajax();
                        }
                    });
                },
                complete: function () {

                },
                success:function(data){
                    switch (data.status){
                        case 0:
                            task.status==1;
                            store.set('token', "");
                            store.oset("UserInfo", {});
                            if (params.token != undefined && data.msg == '用户已注销') {
                                mui.confirm("请先登录!", "提示信息", btn, function(e) {
                                    if (e.index) {
                                        taskCenter.reset();
                                        toWin("login", {});
                                    }else{
                                        task.status==2;
                                        taskCenter.runFaild();
                                    }
                                });
                            } else {
                                task.status==2;
                                taskCenter.runFaild();
                            }
                            break;
                        case 1:
                            p("加载数据成功");
                        default:
                            task.status = 1;
                            taskCenter.runFaild();
                            callback(data);
                    }
                },
                error: function(xhr, type, errorThrown) {
                    task.status=2;
                    task.msg=xhr;
                    taskCenter.runFaild();
                }
            });
        },
        runajax:function () {
            plus.nativeUI.showWaiting('加载中...');
            var tasks=taskCenter.getTasks();
            for(var i=0;i<tasks.length;i++){
                if(tasks[i].status!=1)
                    tasks[i].run();
            }
        }
    };
    //暴露属性
    $.extend(window,extend);
})(window.$||window.mui);
//WebView
(function ($) {
    var _template=function(template){
        return function(obj){
            var key, reg;
            for(key in obj){
                reg = new RegExp('{{' + key + '}}', 'ig');
                template = ( template).replace(reg, obj[key]);
            }
            return template;
        };
    };
    var initWebView=function (winnum,name) {
        var wv=plus.webview.currentWebview(),
            nwv=mui.preload({
                url: wv.id==plus.runtime.appid?'html/default.html':'default.html',
                id: "Win_"+winnum,
                styles: {
                    popGesture: false,
                    errorPage: 'error.html',
                    scrollIndicator: 'none',
                    scrollsToTop: true
                },
                extras: {
                    winnum: winnum
                }
            });
        nwv.addEventListener("hide",function () {
            p('页面隐藏--Win_' + winnum + "----关联显示----" + name);
            nwv.evalJS("Main.clearBase();");
        },true);
        nwv.addEventListener("loaded", function() {
            if (name) {
                nwv.evalJS(_template("newCla('{{name}}');Main.setBase();plus.webview.currentWebview().setPullToRefresh({support:Main.isRefresh});")({name:name}));
            }
            p("缓存Win_" + winnum + "结束");
            nwv.show(C.WANMEL, C.OPENSPEED);
            nwv.addEventListener("show",function(){
                name=nwv.pagename;
                if (name) {
                    nwv.evalJS(_template("newCla('{{name}}');if(Main.reloadAllways)Main.setBase();plus.webview.currentWebview().setPullToRefresh({support:Main.isRefresh});")({name:name}));
                }
                p("缓存Win_" + winnum + "结束");
            },false);
        }, true);
        return nwv;
    };
    var getNextWinNum=function(){
    	var wv=plus.webview.currentWebview();
        if(isNaN(wv.winnum))wv.winnum=-1;
        wv.winnum==wv.winnum>=0?wv.winnum:-1;
        var nextWinNum=wv.winnum+1;
        if(wv.winnum>0){
            var pwv=plus.webview.getWebviewById("Win_"+(wv.winnum-1));
            pwv.evalJS("plus.webview.currentWebview().pagename=pagename");
            if(pwv.pagename==pagename&&pagename==name){
                nextWinNum=pwv.winnum;
            }
        }
        return nextWinNum;
    };
    var extend={
        toWin:function (name,args) {
            //显示waiting
            plus.nativeUI.showWaiting('等待中');
            (args!= undefined && args != null)&&store.oset('allVal', args);

            var nextWinNum=getNextWinNum(),
            	  nwv=plus.webview.getWebviewById("Win_"+nextWinNum);
            if(nwv){
                nwv.show(C.WANMEL, C.OPENSPEED);
            }else{
                nwv=initWebView(nextWinNum,name);
            }
            nwv.pagename=name;
        },
    };
    mui.plusReady(function () {
        var wv = plus.webview.currentWebview();
		wv.setPullToRefresh({
			support: false,
			height: "50px",
			range: "200px",
			contentdown: {
				caption: "下拉可以刷新"
			},
			contentover: {
				caption: "释放立即刷新"
			},
			contentrefresh: {
				caption: "正在刷新..."
			}
		}, function(){
			Main.ajaxload();
		});
    });
    //暴露属性
    $.extend(window,extend);

})(window.$||window.mui);
//Defaultx
(function ($) {
    /**
     * 检查次数的计时器的构造器
     * @param min
     * @param max
     * @param step
     * @param timeout
     * @returns {Function}
     */
    var checkTimes=function(min,max,step,timeout){
        var current=min,
             timer=null;
        return function(){
            if(current>=max){
                return true;
            }else if(!timer){
                timer=setTimeout(function(){
                    current=min;
                },timeout);
            }
            current++;
            return false;
        }
    };
    var checker=checkTimes(1,2,1,1000);
    mui.init({
        beforeback: function () {
            var ws = plus.webview.currentWebview();
            if (ws.winnum == 0) {
                if (checker()) {
                    plus.runtime.quit();
                } else {
                    mui.toast('再按一次退出应用');
                }
                return false;
            } else {
                p("结束运行");
                pwv=plus.webview.getWebviewById("Win_"+(ws.winnum-1));
                pwv.evalJS("if(Main.reloadAllways)Main.setBase()");
            }
            return;
        }
    });
    if(!window.avalon)return;
    //avalon 配置
    window.defaultx = avalon.define({
        $id: 'defaultx',
        tmp_url: 'empty', //模板
        target: "", //当前目标
        bottomid: 0, //首页底部显示按钮
        tmp_loaded: function() {
            p('模板加载完毕');
            //判断如果是多页混合，关闭loading遮罩
            if (Main.pageGroup) {
                plus.nativeUI.closeWaiting();
            };
            Main.tmp_loaded();
        },
    });
    window.newCla=function(name){
        pagename = name;
        defaultx.tmp_url = "../htmljs/" + name + ".html";
        defaultx.target = name;
        Main=window[name+"Cls"]&&window[name+"Cls"].createNew();
        info=window[name+"Ava"];
    };
})(window.$||window.mui);